import unicodedata

tests = {
    "bidirs": {
        "BN": "0000",
        "S": "0009",
        "B": "000A",
        "WS": "000C",
        "ON": "0021",
        "ET": "0023",
        "ES": "002B",
        "CS": "002C",
        "EN": "0030",
        "L": "0041",
        "NSM": "0300",
        "R": "05BE",
        "AN": "0600",
        "AL": "0608",
        "LRE": "202A",
        "RLE": "202B",
        "PDF": "202C",
        "LRO": "202D",
        "RLO": "202E",
        "LRI": "2066",
        "RLI": "2067",
        "FSI": "2068",
        "PDI": "2069"
    },
    "categories": {
        "Cc": "0000",
        "Zs": "0020",
        "Po": "0021",
        "Sc": "0024",
        "Ps": "0028",
        "Pe": "0029",
        "Sm": "002B",
        "Pd": "002D",
        "Nd": "0030",
        "Lu": "0041",
        "Sk": "005E",
        "Pc": "005F",
        "Ll": "0061",
        "So": "00A6",
        "Lo": "00AA",
        "Pi": "00AB",
        "Cf": "00AD",
        "No": "00B2",
        "Pf": "00BB",
        "Lt": "01C5",
        "Lm": "02B0",
        "Mn": "0300",
        "Me": "0488",
        "Mc": "0903",
        "Nl": "16EE",
        "Zl": "2028",
        "Zp": "2029",
        "Cs": "D800",
        "Co": "E000"
    },
    "combinings": {
        "0": "0000",
        "230": "0300",
        "232": "0315",
        "220": "0316",
        "216": "031B",
        "202": "0321",
        "1": "0334",
        "240": "0345",
        "233": "035C",
        "234": "035D",
        "222": "059A",
        "228": "05AE",
        "10": "05B0",
        "11": "05B1",
        "12": "05B2",
        "13": "05B3",
        "14": "05B4",
        "15": "05B5",
        "16": "05B6",
        "17": "05B7",
        "18": "05B8",
        "19": "05B9",
        "20": "05BB",
        "21": "05BC",
        "22": "05BD",
        "23": "05BF",
        "24": "05C1",
        "25": "05C2",
        "30": "0618",
        "31": "0619",
        "32": "061A",
        "27": "064B",
        "28": "064C",
        "29": "064D",
        "33": "0651",
        "34": "0652",
        "35": "0670",
        "36": "0711",
        "7": "093C",
        "9": "094D",
        "84": "0C55",
        "91": "0C56",
        "103": "0E38",
        "107": "0E48",
        "118": "0EB8",
        "122": "0EC8",
        "129": "0F71",
        "130": "0F72",
        "132": "0F74",
        "214": "1DCE",
        "218": "302A",
        "224": "302E",
        "8": "3099",
        "26": "FB1E"
    },
    "decimals": {
        "": "0000",
        "0": "0030",
        "1": "0031",
        "2": "0032",
        "3": "0033",
        "4": "0034",
        "5": "0035",
        "6": "0036",
        "7": "0037",
        "8": "0038",
        "9": "0039"
    },
    "decompositions": {
        "": "0000",
        "<noBreak> 0020": "00A0",
        "<compat> 0020 0308": "00A8",
        "<super> 0061": "00AA",
        "<compat> 0020 0304": "00AF",
        "<super> 0032": "00B2",
        "<super> 0033": "00B3",
        "<compat> 0020 0301": "00B4",
        "<compat> 03BC": "00B5",
        "<compat> 0020 0327": "00B8",
        "<super> 0031": "00B9",
        "<super> 006F": "00BA",
        "<fraction> 0031 2044 0034": "00BC",
        "<fraction> 0031 2044 0032": "00BD",
        "<fraction> 0033 2044 0034": "00BE",
        "0041 0300": "00C0",
        "0041 0301": "00C1",
        "0041 0302": "00C2",
        "0041 0303": "00C3",
        "0041 0308": "00C4",
        "0041 030A": "00C5",
        "0043 0327": "00C7",
        "0045 0300": "00C8",
        "0045 0301": "00C9",
        "0045 0302": "00CA",
        "0045 0308": "00CB",
        "0049 0300": "00CC",
        "0049 0301": "00CD",
        "0049 0302": "00CE",
        "0049 0308": "00CF",
        "004E 0303": "00D1",
        "004F 0300": "00D2",
        "004F 0301": "00D3",
        "004F 0302": "00D4",
        "004F 0303": "00D5",
        "004F 0308": "00D6",
        "0055 0300": "00D9",
        "0055 0301": "00DA",
        "0055 0302": "00DB",
        "0055 0308": "00DC",
        "0059 0301": "00DD",
        "0061 0300": "00E0",
        "0061 0301": "00E1",
        "0061 0302": "00E2",
        "0061 0303": "00E3",
        "0061 0308": "00E4",
        "0061 030A": "00E5",
        "0063 0327": "00E7",
        "0065 0300": "00E8",
        "0065 0301": "00E9",
        "0065 0302": "00EA",
        "0065 0308": "00EB",
        "0069 0300": "00EC",
        "0069 0301": "00ED",
        "0069 0302": "00EE",
        "0069 0308": "00EF",
        "006E 0303": "00F1",
        "006F 0300": "00F2",
        "006F 0301": "00F3",
        "006F 0302": "00F4",
        "006F 0303": "00F5",
        "006F 0308": "00F6",
        "0075 0300": "00F9",
        "0075 0301": "00FA",
        "0075 0302": "00FB",
        "0075 0308": "00FC",
        "0079 0301": "00FD",
        "0079 0308": "00FF",
        "0041 0304": "0100",
        "0061 0304": "0101",
        "0041 0306": "0102",
        "0061 0306": "0103",
        "0041 0328": "0104",
        "0061 0328": "0105",
        "0043 0301": "0106",
        "0063 0301": "0107",
        "0043 0302": "0108",
        "0063 0302": "0109",
        "0043 0307": "010A",
        "0063 0307": "010B",
        "0043 030C": "010C",
        "0063 030C": "010D",
        "0044 030C": "010E",
        "0064 030C": "010F",
        "0045 0304": "0112",
        "0065 0304": "0113",
        "0045 0306": "0114",
        "0065 0306": "0115",
        "0045 0307": "0116",
        "0065 0307": "0117",
        "0045 0328": "0118",
        "0065 0328": "0119",
        "0045 030C": "011A",
        "0065 030C": "011B",
        "0047 0302": "011C",
        "0067 0302": "011D",
        "0047 0306": "011E",
        "0067 0306": "011F",
        "0047 0307": "0120",
        "0067 0307": "0121"
    },
    "digits": {
        "": "0000",
        "0": "0030",
        "1": "0031",
        "2": "0032",
        "3": "0033",
        "4": "0034",
        "5": "0035",
        "6": "0036",
        "7": "0037",
        "8": "0038",
        "9": "0039"
    },
    "names": {
        "<control>": "0008",
        "ASTERISK": "002A",
        "PLUS SIGN": "002B",
        "COLON": "003A",
        "LATIN CAPITAL LETTER J": "004A",
        "LATIN SMALL LETTER I": "0069",
        "LATIN SMALL LETTER Q": "0071",
        "LATIN SMALL LETTER W": "0077",
        "LATIN CAPITAL LETTER C WITH CEDILLA": "00C7",
        "LATIN SMALL LETTER H WITH STROKE": "0127",
        "LATIN CAPITAL LIGATURE IJ": "0132",
        "LATIN CAPITAL LETTER J WITH CIRCUMFLEX": "0134",
        "LATIN CAPITAL LETTER R WITH CEDILLA": "0156",
        "LATIN SMALL LETTER S WITH CARON": "0161",
        "LATIN CAPITAL LETTER T WITH STROKE": "0166",
        "LATIN SMALL LETTER U WITH BREVE": "016D",
        "LATIN SMALL LETTER C WITH HOOK": "0188",
        "LATIN SMALL LETTER F WITH HOOK": "0192",
        "LATIN CAPITAL LETTER GAMMA": "0194",
        "LATIN CAPITAL LETTER T WITH RETROFLEX HOOK": "01AE",
        "LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE": "01BE",
        "LATIN CAPITAL LETTER I WITH DOUBLE GRAVE": "0208",
        "LATIN SMALL LETTER O WITH INVERTED BREVE": "020F",
        "LATIN CAPITAL LETTER N WITH LONG RIGHT LEG": "0220",
        "LATIN SMALL LETTER O WITH DIAERESIS AND MACRON": "022B",
        "LATIN SMALL LETTER O WITH DOT ABOVE": "022F",
        "LATIN SMALL LETTER C WITH CURL": "0255",
        "LATIN SMALL LETTER REVERSED OPEN E WITH HOOK": "025D",
        "LATIN SMALL LETTER G WITH HOOK": "0260",
        "LATIN SMALL LETTER N WITH RETROFLEX HOOK": "0273",
        "LATIN SMALL LETTER BARRED O": "0275",
        "LATIN SMALL LETTER TURNED R": "0279",
        "LATIN LETTER BILABIAL CLICK": "0298",
        "LATIN SMALL LETTER J WITH CROSSED-TAIL": "029D",
        "MODIFIER LETTER ACUTE ACCENT": "02CA",
        "COMBINING BREVE": "0306",
        "COMBINING HOOK ABOVE": "0309",
        "COMBINING LEFT TACK BELOW": "0318",
        "COMBINING DOT BELOW": "0323",
        "COMBINING LONG SOLIDUS OVERLAY": "0338",
        "COMBINING SQUARE BELOW": "033B",
        "COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW": "0356",
        "COMBINING ASTERISK BELOW": "0359",
        "COMBINING LATIN SMALL LETTER I": "0365",
        "GREEK SMALL LETTER PAMPHYLIAN DIGAMMA": "0377",
        "GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS": "0390",
        "GREEK CAPITAL LETTER PI": "03A0",
        "GREEK CAPITAL LETTER TAU": "03A4",
        "GREEK CAPITAL LETTER PHI": "03A6",
        "GREEK SMALL LETTER DELTA": "03B4",
        "GREEK LETTER YOT": "03F3",
        "GREEK LUNATE EPSILON SYMBOL": "03F5",
        "GREEK CAPITAL LUNATE SIGMA SYMBOL": "03F9",
        "CYRILLIC CAPITAL LETTER CHE": "0427",
        "COMBINING CYRILLIC PALATALIZATION": "0484",
        "CYRILLIC CAPITAL LETTER TE WITH DESCENDER": "04AC",
        "CYRILLIC SMALL LETTER TE WITH DESCENDER": "04AD",
        "CYRILLIC SMALL LETTER A WITH DIAERESIS": "04D3",
        "CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK": "04FA",
        "CYRILLIC CAPITAL LETTER KOMI DZJE": "0506",
        "ARMENIAN CAPITAL LETTER KEN": "053F",
        "ARMENIAN SMALL LETTER DA": "0564",
        "ARMENIAN SMALL LETTER VO": "0578",
        "ARMENIAN SMALL LETTER KEH": "0584",
        "HEBREW ACCENT MERKHA KEFULA": "05A6",
        "HEBREW PUNCTUATION NUN HAFUKHA": "05C6",
        "ARABIC SMALL HIGH TAH": "0615",
        "ARABIC SMALL HIGH LIGATURE ALEF WITH LAM WITH YEH": "0616",
        "ARABIC LETTER HAMZA": "0621",
        "ARABIC LETTER FARSI YEH WITH THREE DOTS ABOVE": "063F",
        "ARABIC SUKUN": "0652",
        "ARABIC INVERTED DAMMA": "0657",
        "ARABIC-INDIC DIGIT THREE": "0663",
        "ARABIC-INDIC DIGIT FIVE": "0665",
        "ARABIC LETTER SUPERSCRIPT ALEF": "0670",
        "ARABIC LETTER DDAL": "0688",
        "ARABIC LETTER DUL": "068E",
        "ARABIC LETTER REH WITH FOUR DOTS ABOVE": "0699",
        "ARABIC LETTER KAF WITH DOT ABOVE": "06AC",
        "ARABIC LETTER WAW WITH RING": "06C4",
        "SYRIAC ABBREVIATION MARK": "070F",
        "SYRIAC LETTER LAMADH": "0720",
        "SYRIAC LETTER E": "0725",
        "SYRIAC LETTER RISH": "072A",
        "SYRIAC PTHAHA BELOW": "0731",
        "SYRIAC ESASA BELOW": "073E",
        "SYRIAC QUSHSHAYA": "0741",
        "SYRIAC BARREKH": "074A",
        "ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW": "0758",
        "ARABIC LETTER NOON WITH SMALL TAH": "0768",
        "ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE": "076B",
        "ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH BELOW": "076E",
        "ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE": "077B",
        "THAANA LETTER KAAFU": "0786",
        "THAANA LETTER CHAVIYANI": "0797",
        "THAANA LETTER ZO": "07A1",
        "THAANA EEBEEFILI": "07A9",
        "THAANA UBUFILI": "07AA",
        "THAANA OBOFILI": "07AE",
        "NKO LETTER JONA CHA": "07E9",
        "NKO LAJANYALAN": "07FA",
        "SAMARITAN LETTER NUN": "080D",
        "SAMARITAN PUNCTUATION ANGED": "0832",
        "SAMARITAN PUNCTUATION ATMAAU": "0834",
        "SAMARITAN ABBREVIATION MARK": "0836",
        "SYRIAC LETTER MALAYALAM SSA": "086A",
        "ARABIC LETTER FEH WITH DOT BELOW AND THREE DOTS ABOVE": "08A4",
        "ARABIC LETTER DAL WITH THREE DOTS BELOW": "08AE",
        "ARABIC MARK SIDEWAYS NOON GHUNNA": "08FF",
        "DEVANAGARI LETTER U": "0909",
        "DEVANAGARI LETTER CANDRA E": "090D",
        "DEVANAGARI LETTER KHA": "0916",
        "DEVANAGARI SIGN AVAGRAHA": "093D",
        "DEVANAGARI VOWEL SIGN U": "0941",
        "DEVANAGARI DANDA": "0964",
        "DEVANAGARI LETTER HEAVY YA": "097A",
        "BENGALI LETTER KA": "0995",
        "BENGALI LETTER GA": "0997",
        "BENGALI LETTER JA": "099C",
        "BENGALI LETTER DDA": "09A1",
        "BENGALI LETTER SSA": "09B7",
        "BENGALI VOWEL SIGN AA": "09BE",
        "BENGALI SIGN VIRAMA": "09CD",
        "BENGALI AU LENGTH MARK": "09D7",
        "BENGALI LETTER RRA": "09DC",
        "BENGALI CURRENCY NUMERATOR FOUR": "09F7",
        "GURMUKHI LETTER I": "0A07",
        "GURMUKHI LETTER DDA": "0A21",
        "GURMUKHI LETTER FA": "0A5E",
        "GUJARATI LETTER VOCALIC R": "0A8B",
        "GUJARATI LETTER VOCALIC L": "0A8C",
        "GUJARATI LETTER AU": "0A94",
        "GUJARATI SIGN NUKTA": "0ABC",
        "GUJARATI VOWEL SIGN II": "0AC0",
        "GUJARATI VOWEL SIGN VOCALIC RR": "0AC4",
        "GUJARATI VOWEL SIGN AU": "0ACC",
        "GUJARATI DIGIT SEVEN": "0AED",
        "ORIYA LETTER AA": "0B06",
        "ORIYA LETTER TTHA": "0B20",
        "ORIYA LETTER SA": "0B38",
        "ORIYA VOWEL SIGN AU": "0B4C",
        "ORIYA DIGIT SEVEN": "0B6D",
        "ORIYA ISSHAR": "0B70",
        "TAMIL LETTER E": "0B8E",
        "TAMIL LETTER AI": "0B90",
        "TAMIL LETTER TA": "0BA4",
        "TAMIL LETTER LA": "0BB2",
        "TAMIL LETTER VA": "0BB5",
        "TELUGU LETTER LA": "0C32",
        "TELUGU LETTER LLA": "0C33",
        "TELUGU VOWEL SIGN O": "0C4A",
        "TELUGU LETTER VOCALIC LL": "0C61",
        "TELUGU FRACTION DIGIT THREE FOR ODD POWERS OF FOUR": "0C7B",
        "KANNADA LETTER NYA": "0C9E",
        "KANNADA LETTER BA": "0CAC",
        "KANNADA LETTER VA": "0CB5",
        "KANNADA VOWEL SIGN U": "0CC1",
        "MALAYALAM FRACTION THREE TWENTIETHS": "0D5D",
        "SINHALA LETTER UYANNA": "0D8B",
        "SINHALA LETTER IRUUYANNA": "0D8E",
        "SINHALA LETTER SANYAKA DDAYANNA": "0DAC",
        "SINHALA LETTER ALPAPRAANA PAYANNA": "0DB4",
        "SINHALA LETTER YAYANNA": "0DBA",
        "THAI CHARACTER O ANG": "0E2D",
        "THAI DIGIT ONE": "0E51",
        "LAO ELLIPSIS": "0EAF",
        "LAO VOWEL SIGN MAI KAN": "0EB1",
        "LAO VOWEL SIGN I": "0EB4",
        "LAO TONE MAI THO": "0EC9",
        "LAO DIGIT TWO": "0ED2",
        "TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA": "0F02",
        "TIBETAN MARK INITIAL YIG MGO MDUN MA": "0F04",
        "TIBETAN SIGN RDEL DKAR GNYIS": "0F1B",
        "TIBETAN SIGN NYI ZLA NAA DA": "0F82",
        "TIBETAN SIGN INVERTED MCHU CAN": "0F8C",
        "TIBETAN SUBJOINED LETTER A": "0FB8",
        "TIBETAN CANTILLATION SIGN LIGHT BEAT": "0FC1",
        "MYANMAR LETTER DDHA": "100E",
        "MYANMAR LETTER PA": "1015",
        "MYANMAR LETTER I": "1023",
        "MYANMAR LETTER II": "1024",
        "MYANMAR LETTER UU": "1026",
        "MYANMAR VOWEL SIGN E ABOVE": "1035",
        "MYANMAR DIGIT ONE": "1041",
        "MYANMAR VOWEL SIGN VOCALIC RR": "1057",
        "MYANMAR LETTER WESTERN PWO KAREN PWA": "1066",
        "MYANMAR LETTER SHAN PHA": "107D",
        "MYANMAR SIGN SHAN COUNCIL TONE-3": "108C",
        "MYANMAR SIGN KHAMTI TONE-3": "109B",
        "GEORGIAN CAPITAL LETTER DON": "10A3",
        "GEORGIAN LETTER SHIN": "10E8",
        "GEORGIAN LETTER CIL": "10EC",
        "GEORGIAN LETTER HARD SIGN": "10FE",
        "HANGUL CHOSEONG CHIEUCH": "110E",
        "HANGUL CHOSEONG SIOS-PIEUP-KIYEOK": "1133",
        "HANGUL CHOSEONG CEONGCHIEUMSIOS": "113E",
        "HANGUL JUNGSEONG YEO": "1167",
        "HANGUL JUNGSEONG YEO-U": "117E",
        "HANGUL JUNGSEONG O-U": "1183",
        "HANGUL JUNGSEONG YO-YA": "1184",
        "HANGUL JUNGSEONG I-EU": "119C",
        "HANGUL JUNGSEONG ARAEA-U": "11A0",
        "HANGUL JONGSEONG RIEUL-PHIEUPH": "11B5",
        "HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK": "11D1",
        "HANGUL JONGSEONG MIEUM-SIOS": "11DD",
        "HANGUL JONGSEONG PANSIOS": "11EB",
        "HANGUL JONGSEONG SSANGIEUNG": "11EE",
        "HANGUL JONGSEONG KIYEOK-NIEUN": "11FA",
        "ETHIOPIC SYLLABLE LA": "1208",
        "ETHIOPIC SYLLABLE HHE": "1215",
        "ETHIOPIC SYLLABLE SHAA": "123B",
        "ETHIOPIC SYLLABLE QO": "1246",
        "ETHIOPIC SYLLABLE QOA": "1247",
        "ETHIOPIC SYLLABLE QWE": "124D",
        "ETHIOPIC SYLLABLE QHAA": "1253",
        "ETHIOPIC SYLLABLE TWA": "1277",
        "ETHIOPIC SYLLABLE CAA": "127B",
        "ETHIOPIC SYLLABLE XWI": "128A",
        "ETHIOPIC SYLLABLE XWAA": "128B",
        "ETHIOPIC SYLLABLE KXAA": "12BB",
        "ETHIOPIC SYLLABLE PHARYNGEAL O": "12D6",
        "ETHIOPIC SYLLABLE ZHA": "12E0",
        "ETHIOPIC SYLLABLE YO": "12EE",
        "ETHIOPIC SYLLABLE DDA": "12F8",
        "ETHIOPIC SYLLABLE TSAA": "133B",
        "ETHIOPIC SYLLABLE PI": "1352",
        "ETHIOPIC DIGIT SIX": "136E",
        "ETHIOPIC NUMBER NINETY": "137A",
        "ETHIOPIC SYLLABLE FWEE": "138A",
        "CHEROKEE LETTER O": "13A3",
        "CHEROKEE LETTER HE": "13AE",
        "CHEROKEE LETTER HV": "13B2",
        "CHEROKEE LETTER LI": "13B5",
        "CHEROKEE LETTER DLA": "13DC",
        "CHEROKEE SMALL LETTER YO": "13FA",
        "CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES": "1426",
        "CANADIAN SYLLABICS WEST-CREE PWE": "143B",
        "CANADIAN SYLLABICS TAA": "1456",
        "CANADIAN SYLLABICS WEST-CREE KWE": "1475",
        "CANADIAN SYLLABICS WEST-CREE KWI": "1477",
        "CANADIAN SYLLABICS SOUTH-SLAVEY KEH": "1485",
        "CANADIAN SYLLABICS SOUTH-SLAVEY KOH": "1487",
        "CANADIAN SYLLABICS CWO": "1498",
        "CANADIAN SYLLABICS SAYISI TH": "14A2",
        "CANADIAN SYLLABICS SI": "14EF",
        "CANADIAN SYLLABICS WEST-CREE SWE": "14F7",
        "CANADIAN SYLLABICS ATHAPASCAN S": "1506",
        "CANADIAN SYLLABICS NASKAPI SKWA": "150E",
        "CANADIAN SYLLABICS WEST-CREE SHWOO": "1520",
        "CANADIAN SYLLABICS YA": "152D",
        "CANADIAN SYLLABICS WEST-CREE YWE": "1530",
        "CANADIAN SYLLABICS YWO": "1535",
        "CANADIAN SYLLABICS RAAI": "1545",
        "CANADIAN SYLLABICS NUNAVIK H": "157B",
        "CANADIAN SYLLABICS SAYISI HA": "15C3",
        "CANADIAN SYLLABICS CARRIER GHI": "15C8",
        "CANADIAN SYLLABICS CARRIER RA": "15CF",
        "CANADIAN SYLLABICS CARRIER HWE": "15D8",
        "CANADIAN SYLLABICS CARRIER THE": "15DE",
        "CANADIAN SYLLABICS CARRIER THI": "15E0",
        "CANADIAN SYLLABICS CARRIER PU": "15E8",
        "CANADIAN SYLLABICS CARRIER PI": "15EC",
        "CANADIAN SYLLABICS CARRIER KHE": "15F7",
        "CANADIAN SYLLABICS CARRIER DLA": "162D",
        "CANADIAN SYLLABICS CARRIER TSEE": "165E",
        "CANADIAN SYLLABICS CARRIER TTSO": "1668",
        "OGHAM LETTER UR": "1692",
        "RUNIC LETTER ENG": "16B6",
        "RUNIC LETTER FRANKS CASKET AC": "16F7",
        "TAGALOG LETTER A": "1700",
        "TAGALOG LETTER MA": "170B",
        "HANUNOO LETTER YA": "172C",
        "HANUNOO LETTER LA": "172E",
        "TAGBANWA LETTER NGA": "1765",
        "KHMER LETTER KA": "1780",
        "KHMER LETTER BA": "1794",
        "KHMER VOWEL SIGN AE": "17C2",
        "KHMER SIGN TRIISAP": "17CA",
        "KHMER SIGN AHSDA": "17CF",
        "KHMER SIGN SAMYOK SANNYA": "17D0",
        "KHMER SIGN ATTHACAN": "17DD",
        "KHMER SYMBOL LEK ATTAK PRAM-BEI": "17F8",
        "MONGOLIAN COLON": "1804",
        "MONGOLIAN LETTER YA": "1836",
        "MONGOLIAN LETTER TODO TA": "1850",
        "MONGOLIAN LETTER MANCHU ZHA": "1877",
        "MONGOLIAN LETTER ALI GALI NGA": "188A",
        "CANADIAN SYLLABICS AAY": "18B2",
        "CANADIAN SYLLABICS KWAY": "18B9",
        "CANADIAN SYLLABICS RAY": "18C5",
        "CANADIAN SYLLABICS SAYISI JUU": "18F1",
        "LIMBU VOWEL SIGN OO": "1925",
        "LIMBU DIGIT FIVE": "194B",
        "TAI LE LETTER KHA": "1960",
        "NEW TAI LUE LETTER LOW XA": "1986",
        "NEW TAI LUE LETTER HIGH YA": "198A",
        "NEW TAI LUE VOWEL SIGN UU": "19B4",
        "NEW TAI LUE VOWEL SIGN AY": "19BA",
        "NEW TAI LUE VOWEL SIGN AAY": "19BB",
        "NEW TAI LUE VOWEL SIGN UY": "19BC",
        "NEW TAI LUE LETTER FINAL NG": "19C2",
        "NEW TAI LUE LETTER FINAL K": "19C5",
        "BUGINESE LETTER NGA": "1A02",
        "TAI THAM LETTER RANA": "1A31",
        "TAI THAM LETTER LOW TA": "1A34",
        "TAI THAM CONSONANT SIGN FINAL NGA": "1A59",
        "TAI THAM VOWEL SIGN UU": "1A6A",
        "TAI THAM VOWEL SIGN O": "1A6B",
        "TAI THAM VOWEL SIGN AE": "1A6F",
        "TAI THAM VOWEL SIGN OO": "1A70",
        "TAI THAM VOWEL SIGN THAM AI": "1A72",
        "TAI THAM SIGN SAWAN": "1AA2",
        "COMBINING DIAERESIS-RING": "1AB1",
        "BALINESE VOWEL SIGN TALING REPA TEDUNG": "1B41",
        "BALINESE CARIK PAMUNGKAH": "1B5D",
        "BALINESE MUSICAL SYMBOL DAING": "1B69",
        "BALINESE MUSICAL SYMBOL COMBINING BENDE": "1B72",
        "BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PUNG": "1B79",
        "SUNDANESE LETTER HA": "1BA0",
        "SUNDANESE VOWEL SIGN PANAELAENG": "1BA6",
        "SUNDANESE SIGN VIRAMA": "1BAB",
        "SUNDANESE DIGIT FOUR": "1BB4",
        "SUNDANESE AVAGRAHA": "1BBA",
        "SUNDANESE LETTER REU": "1BBB",
        "BATAK LETTER SIMALUNGUN A": "1BC1",
        "LEPCHA LETTER PHA": "1C10",
        "LEPCHA VOWEL SIGN U": "1C2A",
        "CYRILLIC SMALL LETTER LONG-LEGGED DE": "1C81",
        "GEORGIAN MTAVRULI CAPITAL LETTER GAN": "1C92",
        "GEORGIAN MTAVRULI CAPITAL LETTER NAR": "1C9C",
        "GEORGIAN MTAVRULI CAPITAL LETTER CAN": "1CAA",
        "LATIN SMALL LETTER TURNED OPEN E": "1D08",
        "LATIN SMALL LETTER TURNED OE": "1D14",
        "MODIFIER LETTER CAPITAL BARRED B": "1D2F",
        "MODIFIER LETTER CAPITAL J": "1D36",
        "MODIFIER LETTER SMALL E": "1D49",
        "LATIN SMALL LETTER B WITH MIDDLE TILDE": "1D6C",
        "LATIN SMALL LETTER INSULAR G": "1D79",
        "MODIFIER LETTER SMALL DOTLESS J WITH STROKE": "1DA1",
        "MODIFIER LETTER SMALL IOTA": "1DA5",
        "COMBINING US ABOVE": "1DD2",
        "COMBINING LATIN SMALL LETTER U WITH DIAERESIS": "1DF4",
        "COMBINING KAVYKA ABOVE RIGHT": "1DF6",
        "LATIN CAPITAL LETTER D WITH DOT ABOVE": "1E0A",
        "LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE": "1E1C",
        "LATIN CAPITAL LETTER H WITH CEDILLA": "1E28",
        "LATIN SMALL LETTER L WITH LINE BELOW": "1E3B",
        "LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS": "1E4E",
        "LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW": "1E77",
        "LATIN SMALL LETTER W WITH ACUTE": "1E83",
        "LATIN SMALL LETTER W WITH RING ABOVE": "1E98",
        "LATIN SMALL LETTER A WITH RIGHT HALF RING": "1E9A",
        "LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE": "1EA9",
        "LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE": "1EB2",
        "LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE": "1EBF",
        "LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE": "1EC0",
        "LATIN SMALL LETTER O WITH DOT BELOW": "1ECD",
        "LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE": "1ED5",
        "LATIN SMALL LETTER Y WITH TILDE": "1EF9",
        "GREEK SMALL LETTER IOTA WITH PSILI": "1F30",
        "GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI": "1F3F",
        "GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA": "1F4D",
        "GREEK SMALL LETTER UPSILON WITH PSILI": "1F50",
        "GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI": "1F6E",
        "GREEK SMALL LETTER ETA WITH VARIA": "1F74",
        "GREEK SMALL LETTER ETA WITH OXIA": "1F75",
        "GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI": "1F89",
        "GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI": "1F93",
        "GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI": "1F9D",
        "GREEK DIALYTIKA AND PERISPOMENI": "1FC1",
        "GREEK CAPITAL LETTER EPSILON WITH OXIA": "1FC9",
        "GREEK DASIA AND OXIA": "1FDE",
        "PUNCTUATION SPACE": "2008",
        "EM DASH": "2014",
        "DOUBLE VERTICAL LINE": "2016",
        "BULLET": "2022",
        "HYPHENATION POINT": "2027",
        "PARAGRAPH SEPARATOR": "2029",
        "PER MILLE SIGN": "2030",
        "REVERSED PRIME": "2035",
        "DOUBLE EXCLAMATION MARK": "203C",
        "LOW ASTERISK": "204E",
        "FIVE DOT PUNCTUATION": "2059",
        "VERTICAL FOUR DOTS": "205E",
        "INHIBIT ARABIC FORM SHAPING": "206C",
        "SUBSCRIPT TWO": "2082",
        "KIP SIGN": "20AD",
        "TUGRIK SIGN": "20AE",
        "NORDIC MARK SIGN": "20BB",
        "RUBLE SIGN": "20BD",
        "COMBINING LONG DOUBLE SOLIDUS OVERLAY": "20EB",
        "DEGREE CELSIUS": "2103",
        "CENTRE LINE SYMBOL": "2104",
        "SCRIPT CAPITAL P": "2118",
        "DOUBLE-STRUCK CAPITAL Q": "211A",
        "ROTATED CAPITAL Q": "213A",
        "VULGAR FRACTION ONE THIRD": "2153",
        "VULGAR FRACTION FIVE SIXTHS": "215A",
        "ROMAN NUMERAL SIX": "2165",
        "SMALL ROMAN NUMERAL SIX": "2175",
        "LEFTWARDS TWO HEADED ARROW": "219E",
        "RIGHTWARDS HARPOON WITH BARB UPWARDS": "21C0",
        "LEFTWARDS WHITE ARROW": "21E6",
        "THREE RIGHTWARDS ARROWS": "21F6",
        "RIGHTWARDS ARROW WITH VERTICAL STROKE": "21F8",
        "N-ARY PRODUCT": "220F",
        "INTERSECTION": "2229",
        "CLOCKWISE CONTOUR INTEGRAL": "2232",
        "THEREFORE": "2234",
        "NOT ALMOST EQUAL TO": "2249",
        "ESTIMATES": "2259",
        "EQUIANGULAR TO": "225A",
        "DELTA EQUAL TO": "225C",
        "SQUARE ORIGINAL OF": "2290",
        "CIRCLED RING OPERATOR": "229A",
        "ASSERTION": "22A6",
        "DOUBLE INTERSECTION": "22D2",
        "NOT NORMAL SUBGROUP OF OR EQUAL TO": "22EC",
        "DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL": "22ED",
        "ELECTRIC ARROW": "2301",
        "ARC": "2312",
        "PLACE OF INTEREST SIGN": "2318",
        "X IN A RECTANGLE BOX": "2327",
        "APL FUNCTIONAL SYMBOL QUAD DELTA": "234D",
        "APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS": "2365",
        "APL FUNCTIONAL SYMBOL OMEGA UNDERBAR": "2379",
        "CURLY BRACKET EXTENSION": "23AA",
        "RADICAL SYMBOL BOTTOM": "23B7",
        "SQUARE FOOT": "23CD",
        "METRICAL LONG OVER TWO SHORTS": "23D4",
        "FUSE": "23DB",
        "BLACK RIGHT-POINTING DOUBLE TRIANGLE": "23E9",
        "ALARM CLOCK": "23F0",
        "SYMBOL FOR GROUP SEPARATOR": "241D",
        "CIRCLED DIGIT THREE": "2462",
        "CIRCLED DIGIT EIGHT": "2467",
        "CIRCLED NUMBER EIGHTEEN": "2471",
        "DIGIT SIX FULL STOP": "248D",
        "PARENTHESIZED LATIN SMALL LETTER K": "24A6",
        "PARENTHESIZED LATIN SMALL LETTER L": "24A7",
        "PARENTHESIZED LATIN SMALL LETTER S": "24AE",
        "NEGATIVE CIRCLED NUMBER NINETEEN": "24F3",
        "BOX DRAWINGS LIGHT VERTICAL": "2502",
        "BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT": "251F",
        "BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY": "2521",
        "BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY": "2529",
        "BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY": "2537",
        "BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT": "2544",
        "BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE": "2561",
        "BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT": "2571",
        "SQUARE WITH DIAGONAL CROSSHATCH FILL": "25A9",
        "BLACK UP-POINTING TRIANGLE": "25B2",
        "WHITE DOWN-POINTING TRIANGLE": "25BD",
        "BULLSEYE": "25CE",
        "SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK": "25E9",
        "WHITE SQUARE WITH UPPER RIGHT QUADRANT": "25F3",
        "LOWER RIGHT TRIANGLE": "25FF",
        "THUNDERSTORM": "2608",
        "DESCENDING NODE": "260B",
        "FARSI SYMBOL": "262B",
        "LAST QUARTER MOON": "263E",
        "MALE SIGN": "2642",
        "ARIES": "2648",
        "SCORPIUS": "264F",
        "SAGITTARIUS": "2650",
        "WHITE CLUB SUIT": "2667",
        "BLACK FLAG": "2691",
        "OUTLINED WHITE STAR": "269D",
        "VESTA": "26B6",
        "BASEBALL": "26BE",
        "SQUARED KEY": "26BF",
        "WHITE DIAMOND IN SQUARE": "26CB",
        "HEAVY CIRCLE WITH STROKE AND TWO DOTS ABOVE": "26E3",
        "INVERTED PENTAGRAM": "26E7",
        "MAP SYMBOL FOR LIGHTHOUSE": "26EF",
        "LOWER BLADE SCISSORS": "2703",
        "STAR OF DAVID": "2721",
        "OPEN CENTRE ASTERISK": "2732",
        "HEAVY EIGHT POINTED RECTILINEAR BLACK STAR": "2738",
        "EIGHT TEARDROP-SPOKED PROPELLER ASTERISK": "274A",
        "HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT": "276F",
        "MEDIUM LEFT CURLY BRACKET ORNAMENT": "2774",
        "DINGBAT NEGATIVE CIRCLED DIGIT ONE": "2776",
        "DINGBAT CIRCLED SANS-SERIF DIGIT TWO": "2781",
        "TRIANGLE-HEADED RIGHTWARDS ARROW": "279D",
        "MATHEMATICAL LEFT WHITE SQUARE BRACKET": "27E6",
        "BRAILLE PATTERN DOTS-236": "2826",
        "BRAILLE PATTERN DOTS-347": "284C",
        "BRAILLE PATTERN DOTS-57": "2850",
        "BRAILLE PATTERN DOTS-157": "2851",
        "BRAILLE PATTERN DOTS-148": "2889",
        "BRAILLE PATTERN DOTS-3468": "28AC",
        "UPWARDS ARROW TO BAR": "2912",
        "LEFTWARDS ARROW-TAIL": "2919",
        "ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS": "2935",
        "LEFT BARB DOWN RIGHT BARB UP HARPOON": "294B",
        "LEFT FISH TAIL": "297C",
        "Z NOTATION RIGHT BINDING BRACKET": "298A",
        "CIRCLED WHITE BULLET": "29BE",
        "CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT": "29C3",
        "BOWTIE WITH RIGHT HALF BLACK": "29D2",
        "SHUFFLE PRODUCT": "29E2",
        "LEFT-POINTING CURVED ANGLE BRACKET": "29FC",
        "N-ARY UNION OPERATOR WITH PLUS": "2A04",
        "SEMIDIRECT PRODUCT WITH BOTTOM CLOSED": "2A32",
        "MINUS SIGN IN TRIANGLE": "2A3A",
        "LOGICAL OR WITH DOUBLE UNDERBAR": "2A63",
        "DOUBLE COLON EQUAL": "2A74",
        "LESS-THAN OR SLANTED EQUAL TO": "2A7D",
        "PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO": "2AB1",
        "SUBSET WITH DOT": "2ABD",
        "SUPERSET OF OR EQUAL TO WITH DOT ABOVE": "2AC4",
        "SUBSET OF ABOVE TILDE OPERATOR": "2AC7",
        "SUPERSET OF ABOVE NOT EQUAL TO": "2ACC",
        "SUBSET ABOVE SUPERSET": "2AD3",
        "LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL": "2AE6",
        "WHITE VERY SMALL SQUARE": "2B1E",
        "WHITE HORIZONTAL ELLIPSE": "2B2D",
        "LEFTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE": "2B35",
        "DOWNWARDS TRIANGLE-HEADED DASHED ARROW": "2B6D",
        "RIGHTWARDS TRIANGLE-HEADED PAIRED ARROWS": "2B86",
        "ANTICLOCKWISE TRIANGLE-HEADED RIGHT U-SHAPED ARROW": "2B8C",
        "RIGHTWARDS BLACK ARROW": "2B95",
        "BLACK CURVED DOWNWARDS AND LEFTWARDS ARROW": "2BA8",
        "GROUP MARK": "2BD2",
        "CUPIDO": "2BE0",
        "UPWARDS TWO-HEADED ARROW WITH TRIANGLE ARROWHEADS": "2BED",
        "GLAGOLITIC CAPITAL LETTER TSI": "2C1C",
        "GLAGOLITIC CAPITAL LETTER YU": "2C23",
        "GLAGOLITIC CAPITAL LETTER BIG YUS": "2C28",
        "GLAGOLITIC SMALL LETTER LJUDIJE": "2C3E",
        "GLAGOLITIC SMALL LETTER TVRIDO": "2C45",
        "LATIN SMALL LETTER O WITH LOW RING INSIDE": "2C7A",
        "COPTIC CAPITAL LETTER VIDA": "2C82",
        "COPTIC CAPITAL LETTER UA": "2CA8",
        "COPTIC SMALL LETTER DIALECT-P ALEF": "2CB3",
        "COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE": "2CB6",
        "GEORGIAN SMALL LETTER AN": "2D00",
        "GEORGIAN SMALL LETTER IN": "2D08",
        "GEORGIAN SMALL LETTER KHAR": "2D15",
        "GEORGIAN SMALL LETTER SHIN": "2D18",
        "GEORGIAN SMALL LETTER HOE": "2D25",
        "TIFINAGH LETTER YA": "2D30",
        "TIFINAGH LETTER YAB": "2D31",
        "TIFINAGH LETTER YADH": "2D38",
        "TIFINAGH LETTER BERBER ACADEMY YAH": "2D41",
        "TIFINAGH LETTER TUAREG YANG": "2D51",
        "TIFINAGH LETTER YASH": "2D5B",
        "ETHIOPIC SYLLABLE GGWE": "2D96",
        "COMBINING CYRILLIC LETTER A": "2DF6",
        "COMBINING CYRILLIC LETTER BIG YUS": "2DFE",
        "TILDE WITH RING ABOVE": "2E1B",
        "LEFT LOW PARAPHRASE BRACKET": "2E1C",
        "TILDE WITH DOT ABOVE": "2E1E",
        "TOP RIGHT HALF BRACKET": "2E23",
        "VERTICAL TILDE": "2E2F",
        "VERTICAL SIX DOTS": "2E3D",
        "DOUBLE SUSPENSION MARK": "2E44",
        "LOW KAVYKA": "2E47",
        "PUNCTUS ELEVATUS MARK": "2E4E",
        "CJK RADICAL SECOND THREE": "2E84",
        "CJK RADICAL BAMBOO": "2EAE",
        "CJK RADICAL C-SIMPLIFIED GATE": "2ED4",
        "CJK RADICAL MOUND ONE": "2ED5",
        "KANGXI RADICAL ONE": "2F00",
        "KANGXI RADICAL SECOND": "2F04",
        "KANGXI RADICAL ENTER": "2F0A",
        "KANGXI RADICAL LAME": "2F2A",
        "KANGXI RADICAL SAY": "2F48",
        "KANGXI RADICAL WATER": "2F54",
        "KANGXI RADICAL DOUBLE X": "2F58",
        "KANGXI RADICAL MELON": "2F60",
        "KANGXI RADICAL USE": "2F64",
        "KANGXI RADICAL SPEAR": "2F6D",
        "KANGXI RADICAL SHEEP": "2F7A",
        "KANGXI RADICAL AND": "2F7D",
        "KANGXI RADICAL MINISTER": "2F82",
        "KANGXI RADICAL WALK ENCLOSURE": "2F8F",
        "KANGXI RADICAL CITY": "2FA2",
        "KANGXI RADICAL FRAGRANT": "2FB9",
        "KANGXI RADICAL HAIR": "2FBD",
        "KANGXI RADICAL FIGHT": "2FBE",
        "KANGXI RADICAL RAT": "2FCF",
        "DITTO MARK": "3003",
        "MASU MARK": "303C",
        "HIRAGANA LETTER O": "304A",
        "HIRAGANA LETTER GO": "3054",
        "HIRAGANA LETTER TA": "305F",
        "HIRAGANA LETTER TE": "3066",
        "HIRAGANA LETTER TO": "3068",
        "KATAKANA LETTER I": "30A4",
        "KATAKANA LETTER E": "30A8",
        "KATAKANA LETTER SE": "30BB",
        "KATAKANA VOICED ITERATION MARK": "30FE",
        "HANGUL LETTER RIEUL-HIEUH": "3140",
        "HANGUL LETTER O": "3157",
        "HANGUL LETTER SIOS-PIEUP": "317D",
        "HANGUL LETTER YESIEUNG-PANSIOS": "3183",
        "IDEOGRAPHIC ANNOTATION MIDDLE MARK": "3197",
        "BOPOMOFO LETTER BU": "31A0",
        "BOPOMOFO LETTER NGG": "31AD",
        "BOPOMOFO LETTER OM": "31B1",
        "BOPOMOFO LETTER ONG": "31B2",
        "CJK STROKE HZZP": "31CB",
        "CJK STROKE S": "31D1",
        "PARENTHESIZED HANGUL CIEUC": "3208",
        "CIRCLED HANGUL PHIEUPH": "326C",
        "CIRCLED HANGUL HIEUH": "326D",
        "CIRCLED IDEOGRAPH SEVEN": "3286",
        "CIRCLED IDEOGRAPH ITEM": "32A0",
        "CIRCLED IDEOGRAPH CENTRE": "32A5",
        "CIRCLED IDEOGRAPH RIGHT": "32A8",
        "CIRCLED IDEOGRAPH SUPERVISE": "32AC",
        "CIRCLED NUMBER FORTY FIVE": "32BA",
        "CIRCLED NUMBER FORTY NINE": "32BE",
        "CIRCLED KATAKANA NO": "32E8",
        "CIRCLED KATAKANA HE": "32EC",
        "CIRCLED KATAKANA MI": "32EF",
        "CIRCLED KATAKANA ME": "32F1",
        "SQUARE NOTTO": "3329",
        "SQUARE BAARERU": "332D",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE": "335B",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN": "335F",
        "SQUARE OV": "3375",
        "SQUARE FM": "3399",
        "SQUARE C OVER KG": "33C6",
        "SQUARE MOL": "33D6",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE": "33E2",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO": "33F5",
        "HEXAGRAM FOR WAITING": "4DC4",
        "HEXAGRAM FOR RETURN": "4DD7",
        "HEXAGRAM FOR THE AROUSING THUNDER": "4DF2",
        "YI SYLLABLE IEX": "A005",
        "YI SYLLABLE BIP": "A019",
        "YI SYLLABLE BUX": "A02D",
        "YI SYLLABLE PU": "A04C",
        "YI SYLLABLE BBIP": "A059",
        "YI SYLLABLE BBOX": "A066",
        "YI SYLLABLE NBIT": "A076",
        "YI SYLLABLE HMYR": "A0AD",
        "YI SYLLABLE MAP": "A0B8",
        "YI SYLLABLE MYT": "A0C9",
        "YI SYLLABLE VIT": "A0E2",
        "YI SYLLABLE VIET": "A0E6",
        "YI SYLLABLE DUT": "A114",
        "YI SYLLABLE DUX": "A115",
        "YI SYLLABLE DURX": "A118",
        "YI SYLLABLE TIX": "A11B",
        "YI SYLLABLE DDEX": "A148",
        "YI SYLLABLE HNIEX": "A16D",
        "YI SYLLABLE HLEX": "A1A8",
        "YI SYLLABLE LOT": "A1C7",
        "YI SYLLABLE GIET": "A1DE",
        "YI SYLLABLE GAT": "A1E2",
        "YI SYLLABLE KUR": "A213",
        "YI SYLLABLE GGE": "A228",
        "YI SYLLABLE MGUOP": "A238",
        "YI SYLLABLE HXIEP": "A24D",
        "YI SYLLABLE CY": "A2CC",
        "YI SYLLABLE ZZUX": "A2E2",
        "YI SYLLABLE SY": "A326",
        "YI SYLLABLE SSIT": "A32A",
        "YI SYLLABLE SSYT": "A340",
        "YI SYLLABLE ZHO": "A34F",
        "YI SYLLABLE CHUOP": "A368",
        "YI SYLLABLE CHY": "A378",
        "YI SYLLABLE RRE": "A386",
        "YI SYLLABLE NRAT": "A394",
        "YI SYLLABLE NREX": "A39C",
        "YI SYLLABLE NREP": "A39E",
        "YI SYLLABLE SHUOP": "A3B1",
        "YI SYLLABLE SHEP": "A3B9",
        "YI SYLLABLE RUOX": "A3CA",
        "YI SYLLABLE REP": "A3D3",
        "YI SYLLABLE JIET": "A3E4",
        "YI SYLLABLE JO": "A3EE",
        "YI SYLLABLE QUT": "A40C",
        "YI SYLLABLE QYT": "A412",
        "YI SYLLABLE JJUT": "A427",
        "YI SYLLABLE NJIEX": "A436",
        "YI SYLLABLE XIP": "A460",
        "YI SYLLABLE YOX": "A47E",
        "YI RADICAL QOT": "A490",
        "YI RADICAL SHUR": "A4BA",
        "LISU LETTER TA": "A4D4",
        "LISU LETTER OE": "A4F7",
        "LISU LETTER TONE MYA NA": "A4FC",
        "LISU LETTER TONE MYA JEU": "A4FD",
        "VAI SYLLABLE ZHEE": "A519",
        "VAI SYLLABLE HIN": "A527",
        "VAI SYLLABLE MI": "A546",
        "VAI SYLLABLE NDA": "A561",
        "VAI SYLLABLE ZA": "A564",
        "VAI SYLLABLE WU": "A599",
        "VAI SYLLABLE MGBU": "A5A0",
        "VAI SYLLABLE RU": "A5A9",
        "VAI SYLLABLE ZU": "A5AE",
        "VAI SYLLABLE BHO": "A5C2",
        "VAI SYLLABLE NGGO": "A5DC",
        "VAI SYLLABLE GBE": "A5EF",
        "VAI SYLLABLE SHE": "A5FC",
        "CYRILLIC CAPITAL LETTER REVERSED DZE": "A644",
        "COMBINING CYRILLIC LETTER HARD SIGN": "A678",
        "BAMUM LETTER KU": "A6A3",
        "BAMUM LETTER O": "A6A7",
        "BAMUM LETTER TAA": "A6B0",
        "BAMUM LETTER YA": "A6C2",
        "BAMUM LETTER SHO": "A6D6",
        "BAMUM LETTER KOVUU": "A6EE",
        "LATIN SMALL LETTER EGYPTOLOGICAL AIN": "A725",
        "LATIN LETTER SMALL CAPITAL F": "A730",
        "LATIN CAPITAL LETTER AV WITH HORIZONTAL BAR": "A73A",
        "LATIN CAPITAL LETTER K WITH DIAGONAL STROKE": "A742",
        "LATIN SMALL LETTER L WITH HIGH STROKE": "A749",
        "LATIN CAPITAL LETTER O WITH LONG STROKE OVERLAY": "A74A",
        "LATIN CAPITAL LETTER R ROTUNDA": "A75A",
        "LATIN LETTER SMALL CAPITAL RUM": "A776",
        "LATIN SMALL LETTER TUM": "A777",
        "LATIN SMALL LETTER SALTILLO": "A78C",
        "LATIN SMALL LETTER C WITH PALATAL HOOK": "A794",
        "LATIN SMALL LETTER S WITH OBLIQUE STROKE": "A7A9",
        "LATIN SMALL LETTER BETA": "A7B5",
        "SYLOTI NAGRI LETTER A": "A800",
        "SYLOTI NAGRI VOWEL SIGN E": "A826",
        "NORTH INDIC FRACTION ONE HALF": "A831",
        "NORTH INDIC PLACEHOLDER MARK": "A837",
        "PHAGS-PA LETTER NYA": "A847",
        "SAURASHTRA LETTER MA": "A8AA",
        "SAURASHTRA VOWEL SIGN VOCALIC L": "A8BC",
        "SAURASHTRA VOWEL SIGN E": "A8BE",
        "SAURASHTRA VOWEL SIGN AI": "A8C0",
        "SAURASHTRA SIGN CANDRABINDU": "A8C5",
        "COMBINING DEVANAGARI DIGIT SEVEN": "A8E7",
        "COMBINING DEVANAGARI LETTER NA": "A8ED",
        "COMBINING DEVANAGARI SIGN AVAGRAHA": "A8F1",
        "DEVANAGARI SIGN CANDRABINDU VIRAMA": "A8F3",
        "DEVANAGARI SIGN CANDRABINDU AVAGRAHA": "A8F7",
        "KAYAH LI DIGIT ONE": "A901",
        "KAYAH LI LETTER BA": "A919",
        "KAYAH LI LETTER CA": "A921",
        "KAYAH LI TONE CALYA": "A92C",
        "REJANG LETTER A": "A946",
        "REJANG CONSONANT SIGN NG": "A94F",
        "HANGUL CHOSEONG TIKEUT-SIOS": "A962",
        "HANGUL CHOSEONG RIEUL-PIEUP": "A969",
        "JAVANESE LETTER NGA LELET RASWADI": "A98B",
        "MYANMAR LETTER SHAN NNA": "A9E3",
        "MYANMAR TAI LAING DIGIT SIX": "A9F6",
        "CHAM LETTER JA": "AA0E",
        "CHAM LETTER TA": "AA13",
        "CHAM LETTER BHA": "AA1E",
        "CHAM VOWEL SIGN II": "AA2B",
        "MYANMAR LETTER KHAMTI RA": "AA73",
        "MYANMAR SIGN PAO KAREN TONE": "AA7B",
        "TAI VIET LETTER LOW KHO": "AA82",
        "TAI VIET LETTER HIGH CHO": "AA8D",
        "TAI VIET LETTER HIGH YO": "AAA5",
        "TAI VIET LETTER LOW VO": "AAAA",
        "LATIN SMALL LETTER BLACKLETTER E": "AB32",
        "LATIN SMALL LETTER SCRIPT R": "AB4B",
        "LATIN SMALL LETTER UI": "AB50",
        "LATIN SMALL LETTER CHI WITH LOW LEFT SERIF": "AB55",
        "CHEROKEE SMALL LETTER HA": "AB7D",
        "CHEROKEE SMALL LETTER NE": "AB91",
        "CHEROKEE SMALL LETTER QUE": "AB97",
        "CHEROKEE SMALL LETTER QUI": "AB98",
        "CHEROKEE SMALL LETTER DE": "ABA5",
        "CHEROKEE SMALL LETTER TLU": "ABB1",
        "MEETEI MAYEK LETTER JIL": "ABD6",
        "MEETEI MAYEK CHEIKHEI": "ABEB",
        "MEETEI MAYEK APUN IYEK": "ABED",
        "HANGUL JONGSEONG SSANGMIEUM": "D7E0",
        "HANGUL JONGSEONG MIEUM-PIEUP-SIOS": "D7E1",
        "CJK COMPATIBILITY IDEOGRAPH-F910": "F910",
        "CJK COMPATIBILITY IDEOGRAPH-F928": "F928",
        "CJK COMPATIBILITY IDEOGRAPH-F93D": "F93D",
        "CJK COMPATIBILITY IDEOGRAPH-F948": "F948",
        "CJK COMPATIBILITY IDEOGRAPH-F94E": "F94E",
        "CJK COMPATIBILITY IDEOGRAPH-F99D": "F99D",
        "CJK COMPATIBILITY IDEOGRAPH-F99E": "F99E",
        "CJK COMPATIBILITY IDEOGRAPH-F9B6": "F9B6",
        "CJK COMPATIBILITY IDEOGRAPH-F9BC": "F9BC",
        "CJK COMPATIBILITY IDEOGRAPH-F9D7": "F9D7",
        "CJK COMPATIBILITY IDEOGRAPH-FA52": "FA52",
        "CJK COMPATIBILITY IDEOGRAPH-FA5C": "FA5C",
        "CJK COMPATIBILITY IDEOGRAPH-FA63": "FA63",
        "CJK COMPATIBILITY IDEOGRAPH-FA69": "FA69",
        "CJK COMPATIBILITY IDEOGRAPH-FA7A": "FA7A",
        "CJK COMPATIBILITY IDEOGRAPH-FA86": "FA86",
        "CJK COMPATIBILITY IDEOGRAPH-FA89": "FA89",
        "CJK COMPATIBILITY IDEOGRAPH-FAB5": "FAB5",
        "CJK COMPATIBILITY IDEOGRAPH-FAB6": "FAB6",
        "CJK COMPATIBILITY IDEOGRAPH-FAB8": "FAB8",
        "CJK COMPATIBILITY IDEOGRAPH-FAB9": "FAB9",
        "CJK COMPATIBILITY IDEOGRAPH-FABC": "FABC",
        "LATIN SMALL LIGATURE FF": "FB00",
        "ARMENIAN SMALL LIGATURE MEN ECH": "FB14",
        "HEBREW LETTER MEM WITH DAGESH": "FB3E",
        "ARABIC LETTER NGOEH MEDIAL FORM": "FB9D",
        "ARABIC SYMBOL DOT ABOVE": "FBB2",
        "ARABIC LETTER NG FINAL FORM": "FBD4",
        "ARABIC LETTER FARSI YEH MEDIAL FORM": "FBFF",
        "ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM": "FC2C",
        "ARABIC LIGATURE QAF WITH YEH ISOLATED FORM": "FC36",
        "ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM": "FC37",
        "ARABIC LIGATURE TEH WITH REH FINAL FORM": "FC70",
        "ARABIC LIGATURE FEH WITH YEH FINAL FORM": "FC7D",
        "ARABIC LIGATURE QAF WITH HAH INITIAL FORM": "FCC2",
        "ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM": "FCF3",
        "ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM": "FD02",
        "ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM": "FD09",
        "ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM": "FD51",
        "ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM": "FD62",
        "ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM": "FD7F",
        "ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM": "FDA0",
        "ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM": "FDA1",
        "ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM": "FDC1",
        "ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM": "FDF1",
        "ARABIC LIGATURE SALAM ISOLATED FORM": "FDF5",
        "ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM": "FDFA",
        "PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET": "FE3C",
        "PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET": "FE43",
        "SMALL RIGHT PARENTHESIS": "FE5A",
        "SMALL RIGHT CURLY BRACKET": "FE5C",
        "SMALL NUMBER SIGN": "FE5F",
        "ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM": "FE83",
        "ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM": "FE87",
        "ARABIC LETTER BEH FINAL FORM": "FE90",
        "ARABIC LETTER TEH MARBUTA ISOLATED FORM": "FE93",
        "ARABIC LETTER JEEM INITIAL FORM": "FE9F",
        "ARABIC LETTER HAH MEDIAL FORM": "FEA4",
        "ARABIC LETTER KHAH INITIAL FORM": "FEA7",
        "ARABIC LETTER SEEN ISOLATED FORM": "FEB1",
        "ARABIC LETTER SHEEN FINAL FORM": "FEB6",
        "ARABIC LETTER DAD FINAL FORM": "FEBE",
        "ARABIC LETTER ZAH INITIAL FORM": "FEC7",
        "ARABIC LETTER AIN ISOLATED FORM": "FEC9",
        "ARABIC LETTER GHAIN FINAL FORM": "FECE",
        "ARABIC LETTER FEH FINAL FORM": "FED2",
        "ARABIC LETTER FEH INITIAL FORM": "FED3",
        "ARABIC LETTER ALEF MAKSURA FINAL FORM": "FEF0",
        "FULLWIDTH DIGIT FOUR": "FF14",
        "FULLWIDTH LATIN CAPITAL LETTER I": "FF29",
        "FULLWIDTH LATIN CAPITAL LETTER J": "FF2A",
        "FULLWIDTH LATIN CAPITAL LETTER L": "FF2C",
        "FULLWIDTH LATIN CAPITAL LETTER N": "FF2E",
        "FULLWIDTH LATIN SMALL LETTER R": "FF52",
        "FULLWIDTH LATIN SMALL LETTER T": "FF54",
        "FULLWIDTH TILDE": "FF5E",
        "HALFWIDTH KATAKANA LETTER SMALL O": "FF6B",
        "HALFWIDTH KATAKANA LETTER A": "FF71",
        "HALFWIDTH KATAKANA LETTER E": "FF74",
        "HALFWIDTH KATAKANA LETTER TA": "FF80",
        "HALFWIDTH HANGUL LETTER YA": "FFC4"
    },
    "numerics": {
        "": "0000",
        "0": "0030",
        "1": "0031",
        "2": "0032",
        "3": "0033",
        "4": "0034",
        "5": "0035",
        "6": "0036",
        "7": "0037",
        "8": "0038",
        "9": "0039",
        "1/4": "00BC",
        "1/2": "00BD",
        "3/4": "00BE",
        "1/16": "09F4",
        "1/8": "09F5",
        "3/16": "09F6",
        "16": "09F9",
        "10": "0BF0",
        "100": "0BF1",
        "1000": "0BF2",
        "1/160": "0D58",
        "1/40": "0D59",
        "3/80": "0D5A",
        "1/20": "0D5B",
        "1/10": "0D5C",
        "3/20": "0D5D",
        "1/5": "0D5E",
        "3/2": "0F2B",
        "5/2": "0F2C",
        "7/2": "0F2D",
        "9/2": "0F2E",
        "11/2": "0F2F",
        "13/2": "0F30",
        "15/2": "0F31",
        "17/2": "0F32",
        "-1/2": "0F33",
        "20": "1373",
        "30": "1374",
        "40": "1375",
        "50": "1376",
        "60": "1377",
        "70": "1378",
        "80": "1379",
        "90": "137A",
        "10000": "137C",
        "17": "16EE",
        "18": "16EF",
        "19": "16F0",
        "1/7": "2150",
        "1/9": "2151",
        "1/3": "2153",
        "2/3": "2154",
        "2/5": "2156",
        "3/5": "2157",
        "4/5": "2158",
        "1/6": "2159",
        "5/6": "215A",
        "3/8": "215C",
        "5/8": "215D",
        "7/8": "215E",
        "11": "216A",
        "12": "216B",
        "500": "216E",
        "5000": "2181",
        "50000": "2187",
        "100000": "2188",
        "13": "246C",
        "14": "246D",
        "15": "246E",
        "21": "3251",
        "22": "3252",
        "23": "3253",
        "24": "3254",
        "25": "3255",
        "26": "3256",
        "27": "3257",
        "28": "3258",
        "29": "3259",
        "31": "325B",
        "32": "325C",
        "33": "325D",
        "34": "325E",
        "35": "325F",
        "36": "32B1",
        "37": "32B2",
        "38": "32B3",
        "39": "32B4",
        "41": "32B6",
        "42": "32B7",
        "43": "32B8",
        "44": "32B9",
        "45": "32BA",
        "46": "32BB",
        "47": "32BC",
        "48": "32BD",
        "49": "32BE"
    }
}

for bidir, cp in tests["bidirs"].items():
    assert bidir == unicodedata.bidirectional(chr(int(cp, 16)))

print("bidirectional ok")

for category, cp in tests["categories"].items():
    assert category == unicodedata.category(chr(int(cp, 16)))

print("categories ok")

for comb, cp in tests["combinings"].items():
    assert int(comb) == unicodedata.combining(chr(int(cp, 16)))

print("combining ok")

for decimal, cp in tests["decimals"].items():
    if decimal:
        assert eval(decimal) == unicodedata.decimal(chr(int(cp, 16)))

print("decimals ok")

for decomp, cp in tests["decompositions"].items():
    assert decomp == unicodedata.decomposition(chr(int(cp, 16)))

print("decomposition ok")

for digit, cp in tests["digits"].items():
    if digit:
        assert eval(digit) == unicodedata.digit(chr(int(cp, 16)))

print("digits ok")

for name, cp in tests["names"].items():
    assert name == unicodedata.name(chr(int(cp, 16)))

print("names ok")

for numeric, cp in tests["numerics"].items():
    if numeric:
        assert eval(numeric) == unicodedata.numeric(chr(int(cp, 16)))

print("numeric ok")

assert unicodedata.normalize('NFC', chr(0x2162)) == "Ⅲ"
assert unicodedata.normalize('NFD', chr(0x2162)) == "Ⅲ"
assert unicodedata.normalize('NFKC', chr(0x2162)) == "III"
assert unicodedata.normalize('NFKD', chr(0x2162)) == "III"

print("normalize ok")
